/* Client program to demonstrate usage of named-pipe */
#include "fifoCommon.h"

#define MYAPP "[fifoClient]"

int main(int argc, char *argv[])
{
  int wrfd, rdfd, numread;
  char rdbuf[MAX_BUF_SIZE];
  
  /* Check if an argument was specified. */
  
  if (argc != 2) {
    printf("Usage : %s <string to be sent to the server>\n", argv[0]);
    exit (1);
  }
  
  /* Open the first named pipe for writing */
  printf("%s Opening the named-pipe \"%s\" for writing\n",MYAPP,FIFO_TO_SERVER);
  wrfd = open(FIFO_TO_SERVER, O_WRONLY);
  
  /* Open the second named pipe for reading */
  printf("%s Opening the named-pipe \"%s\" for reading\n",MYAPP,FIFO_FROM_SERVER);
  rdfd = open(FIFO_FROM_SERVER, O_RDONLY);
  
  /* Write to the pipe */
  printf("%s Writing to the named-pipe \"%s\"\n",MYAPP,FIFO_TO_SERVER);
  write(wrfd, argv[1], strlen(argv[1])+1);
  
  /* Read from the pipe */
  printf("%s Reading from the named-pipe \"%s\"\n",MYAPP,FIFO_FROM_SERVER);
  numread = read(rdfd, rdbuf, MAX_BUF_SIZE);
  
  printf("%s Full Duplex Client : Read From the Pipe : %s\n", MYAPP, rdbuf);

  exit(0);
}
