/* Server program to demonstrate usage of named-pipe */
#include "fifoCommon.h"

#define MYAPP "[fifoServer]"

int main(int argc, char *argv[])
{
  int rdfd, wrfd, ret_val, count, numread;
  char buf[MAX_BUF_SIZE];
  
  /* Create the first named-pipe */
  printf("%s Creating the named-pipe \"%s\"\n",MYAPP,FIFO_TO_SERVER);
  ret_val = mkfifo(FIFO_TO_SERVER, 0666);
  if ((ret_val == -1) && (errno != EEXIST)) {
    perror("Error creating the named pipe");
    exit (1);
  }
  
  /* Create the second named-pipe */
  printf("%s Creating the named-pipe \"%s\"\n",MYAPP,FIFO_FROM_SERVER);
  ret_val = mkfifo(FIFO_FROM_SERVER, 0666);
  if ((ret_val == -1) && (errno != EEXIST)) {
    perror("Error creating the named pipe");
    exit (1);
  }
  
  /* Open the first named pipe for reading */
  printf("%s Opening the named-pipe \"%s\" for reading\n",MYAPP,FIFO_TO_SERVER);
  rdfd = open(FIFO_TO_SERVER, O_RDONLY);
  
  /* Open the second named pipe for writing */
  printf("%s Opening the named-pipe \"%s\" for writing\n",MYAPP,FIFO_FROM_SERVER);
  wrfd = open(FIFO_FROM_SERVER, O_WRONLY);
  
  /* Read from the first pipe */
  printf("%s Reading from the named-pipe \"%s\"\n",MYAPP,FIFO_TO_SERVER);
  numread = read(rdfd, buf, MAX_BUF_SIZE);
  
  printf("%s Full Duplex Server : Read From the pipe : %s\n",MYAPP,buf);
  
  /* Convert to the string to upper case */
  printf("%s Converting the received string to upper case\n",MYAPP);
  count = 0;
  while (count < numread) {
    buf[count] = toupper(buf[count]);
    count++;
  }

  /* Write the converted string back to the second pipe */    
  printf("%s Reading to the named-pipe \"%s\"\n",MYAPP,FIFO_FROM_SERVER);
  write(wrfd, buf, strlen(buf)+1);
  
  exit(0);
}
